//װǼ

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#define Nrhoc 80
#define drhoc 0.1//ܶ10^19Ͼͱ 
 
//ͨrhocyc
double yc(double rhoc){
	double y;
	y=sqrt(pow((rhoc/2.094),2.0/3.0)+1.0);
	return(y);
}

//yԤ
double ypre(double r,double y0,double m0,double dr){
	double y;
	y=y0-0.2913*m0*pow(r,-2.0)*(dr*0.5);
	return(y);
} 

//mԤ
double mpre(double r,double y0,double m0,double dr){
	double m;
	m=m0+26.31*pow(r,2.0)*pow((y0*y0-1.0),1.5)*(dr*0.5);
	return(m);
}

//yУ
double ycor(double r,double y0,double mpre,double dr){
	double y;
	y=y0-0.2913*mpre*pow(r,-2.0)*dr;
	return(y);
}

//mУ
double mcor(double r,double ypre,double m0,double dr){
	double m;
	m=m0+26.31*pow(r,2.0)*pow((ypre*ypre-1.0),1.5)*dr;
	return(m);
}

// 
void output(double rhoc,double dr,FILE *fp){
	double r,y,m=0.0;
	y=yc(rhoc);
	double yhalf,mhalf,y1,m1;
	int i=0;
	do{
		r=(double)i*dr;
		if(i==0){
			r=0.5*dr;//0 
		}
		yhalf=ypre(r,y,m,dr);
		mhalf=mpre(r,y,m,dr);
		if(yhalf<=1.0){
			y=yhalf;
			m=mhalf;
			break;
		}
		r=r+0.5*dr;
        y=ycor(r,y,mhalf,dr);
		m=mcor(r,yhalf,m,dr);				
		i=i+1;
	}while(y>1.0);
	fprintf(fp,"%2.1f\t%2.6f\t%2.6f\n",log10(rhoc),-log(r),m);
}
 
//
int main(){
	double rhoc,dr;
	int i;
	FILE *fp;
	fp=fopen("data1.xlsx","w");
	for(i=0;i<=Nrhoc;i++){
		rhoc=pow(10.0,(double)i*drhoc);
		dr=pow(10.0,-6.0)*pow(rhoc,-1.0/3.0);
		output(rhoc,dr,fp);
	}
	fclose(fp);
	return(0);
} 
